import request from '@/axios'
import { download } from '@/api/common'

const BASE_URL = '/system-center/tManageBoundInfo'
// 列表--分页
export const getBoundListApi = (params: any): Promise<IResponse> => {
  return request.get({ url: BASE_URL + '/list', params })
}
// 保存数据
export const saveDataApi = (data, isEdit = false): Promise<IResponse> => {
  if (isEdit) {
    return request.put({ url: BASE_URL + '/edit', data })
  } else {
    return request.post({ url: BASE_URL + '/save', data })
  }
}
// 详情
export const getBoundDetApi = (id: string) => {
  return request.get({ url: BASE_URL + '/findById?id=' + id })
}
// 删除
export const delBoundListApi = (ids: string): Promise<IResponse> => {
  return request.delete({ url: BASE_URL + '/delete?ids=' + ids })
}
// 导出
export const exportBoundListApi = (data: any) => {
  return download(BASE_URL + '/export', data, `管界数据维护_${new Date().getTime()}.xlsx`)
}
