import request from '@/axios'
import { download } from '../common'

// 获取列表数据
export const getDeptListApi = (params: any): Promise<IResponse> => {
  return request.get({ url: '/system/management/dept/list', params })
}
// 保存数据
export const saveDeptApi = (data: any): Promise<IResponse> => {
  return request.post({ url: '/system/management/dept', data })
}
// 修改数据
export const updateDeptApi = (data: any): Promise<IResponse> => {
  return request.put({ url: '/system/management/dept', data })
}
// 根据ID获取数据
export const getDeptDetApi = (id: string) => {
  return request.get({ url: `/system/management/dept/${id}` })
}
// 删除列表数据
export const delDeptListApi = (ids: string | number): Promise<IResponse> => {
  return request.delete({ url: `/system/management/dept/${ids}`, data: { ids } })
}

// 导出
export const exportDeptListApi = (data: any) => {
  return download('/system/management/dept/exportDept', data, `部门_${new Date().getTime()}.xlsx`)
}
