import request from '@/axios'
import { download } from '@/api/common'

const BASE_URL = '/system-center/management/lineInfo'
// 列表--分页
export const getLineListApi = (params: any): Promise<IResponse> => {
  return request.get({ url: BASE_URL + '/list', params })
}
// 保存数据
export const saveDataApi = (data, isEdit = false): Promise<IResponse> => {
  if (isEdit) {
    return request.put({ url: BASE_URL + '/update', data })
  } else {
    return request.post({ url: BASE_URL, data })
  }
}
// 新增
export const saveLineApi = (data): Promise<IResponse> => {
  return request.post({ url: BASE_URL, data })
}
// 编辑
export const editLineApi = (data): Promise<IResponse> => {
  return request.put({ url: BASE_URL + '/update', data })
}
// 详情
export const getLineDetApi = (id: string) => {
  return request.get({ url: BASE_URL + '/' + id })
}
// 删除
export const delLineListApi = (ids: string): Promise<IResponse> => {
  return request.delete({ url: BASE_URL + '/delete?ids=' + ids })
}
// 导出
export const exportLineListApi = (data: any) => {
  return download(BASE_URL + '/export', data, `线路数据维护_${new Date().getTime()}.xlsx`)
}
