import request from '@/axios'
import { download } from '@/api/common'

export const getPostListApi = (params: any): Promise<IResponse> => {
  return request.get({ url: '/system/management/post/list', params })
}

export const saveDataApi = (data, isEdit = false): Promise<IResponse> => {
  if (isEdit) {
    return request.put({ url: '/system/management/post', data })
  } else {
    return request.post({ url: '/system/management/post', data })
  }
}
export const savePostApi = (data): Promise<IResponse> => {
  return request.post({ url: '/system/management/post', data })
}

export const editPostApi = (data): Promise<IResponse> => {
  return request.put({ url: '/system/management/post', data })
}

export const getPostDetApi = (id: string) => {
  return request.get({ url: '/system/management/post/' + id })
}
// 岗位下拉选
export const getPostOptionSelectApi = (id?: string) => {
  return request.get({ url: '/system/management/post/optionselect' })
}

export const delPostListApi = (ids: string): Promise<IResponse> => {
  return request.delete({ url: '/system/management/post/' + ids })
}

export const exportPostListApi = (data: any) => {
  return download('/system/management/post/export', data, `post_${new Date().getTime()}.xlsx`)
}
