import request from '@/axios'

export const getUserInfoApi = (params: any): Promise<IResponse> => {
  return request.get({ url: '/system/management/user/getInfo', params })
}
// 用户头像上传
export const uploadAvatarApi = (data: any): Promise<IResponse> => {
  return request.post({
    url: '/system/management/user/profile/avatar',
    data: data,
    headers: {
      'Content-Type': 'multipart/form-data; boundary=----WebKitFormBoundaryBJa1VA8XEFgXAltY'
    }
  })
}

// 查询用户个人信息
export const getUserProfileApi = (): Promise<IResponse> => {
  return request.get({ url: '/system/management/user/profile' })
}

// 修改用户个人信息
export const updateUserProfileApi = (data: any): Promise<IResponse> => {
  return request.put({ url: '/system/management/user/profile', data: data })
}

export const updateUserPwdApi = (data: any): Promise<IResponse> => {
  return request.put({ url: '/system/management/user/profile/updatePwd', params: data })
}
