import type { RouteMeta } from 'vue-router'
import { Icon } from '@/components/Icon'
import { useI18n } from '@/hooks/web/useI18n'

export const useRenderMenuTitle = () => {
  const renderMenuTitle = (meta: RouteMeta, isItem?: boolean) => {
    const { t } = useI18n()
    const { title = 'Please set title', icon } = meta
    return icon ? (
      <>
        <Icon icon={meta.icon}></Icon>
        <span
          class="v-menu__title overflow-hidden overflow-ellipsis whitespace-nowrap"
          title={t(title as string)}
        >
          {t(title as string)}
        </span>
      </>
    ) : (
      <span
        class="v-menu__title overflow-hidden overflow-ellipsis whitespace-nowrap"
        title={t(title as string)}
      >
        {isItem ? <span class={'text-30px mr-5px circle-dots '}></span> : null}
        {t(title as string)}
      </span>
    )
  }

  return {
    renderMenuTitle
  }
}
