/**
 * 请求成功状态码
 */
export const SUCCESS_CODE = '00000'

/**
 * 请求contentType
 */
export const CONTENT_TYPE: AxiosContentType = 'application/json'

/**
 * 请求超时时间
 */
export const REQUEST_TIMEOUT = 60000

/**
 * 不重定向白名单
 */
export const NO_REDIRECT_WHITE_LIST = ['/login']

/**
 * 不重置路由白名单
 */
export const NO_RESET_WHITE_LIST = ['Redirect', 'Login', 'NoFind', 'Root']

/**
 * 表格默认过滤列设置字段
 */
export const DEFAULT_FILTER_COLUMN = ['expand', 'selection']

/**
 * 是否根据headers->content-type自动转换数据格式
 */
export const TRANSFORM_REQUEST_DATA = true

/**
 * 列宽查询接口
 * 1：系统管理 2：工务设备数据管理
 */
export const WIDTH_INTERFACE_URL = {
  1: '/railwayServer/customWidth/findByFlag',
  2: '/railway-analysis-server/customWidth/findByFlag'
}

/**
 * 列宽新增接口
 * 1：系统管理 2：工务设备数据管理
 */
export const ADD_WIDTH_INTERFACE_URL = {
  1: '/railwayServer/customWidth/save',
  2: '/railway-analysis-server/customWidth/save'
}

/**
 * 列宽编辑接口
 * 1：系统管理 2：工务设备数据管理
 */
export const EDIT_WIDTH_INTERFACE_URL = {
  1: '/railwayServer/customWidth/update',
  2: '/railway-analysis-server/customWidth/update'
}

/**
 * 表格过滤列字段&搜索字段接口
 * 1：系统管理 2：工务设备数据管理
 */
export const FIELD_INTERFACE_URL = {
  1: '/system/tableHeaderFilter/findByUserIdAndModuleName',
  2: '/railway-analysis-server/tableHeaderFilter/findByUserIdAndModuleName'
}
/**
 * 表格过滤列字段&搜索字段新增保存接口
 * 1：系统管理 2：工务设备数据管理
 */
export const SAVE_FIELD_INTERFACE_URL = {
  1: '/system/tableHeaderFilter/save',
  2: '/railway-analysis-server/tableHeaderFilter/save'
}
/**
 * 表格过滤列字段&搜索字段编辑保存接口
 * 1：系统管理 2：工务设备数据管理
 */
export const UPDATE_FIELD_INTERFACE_URL = {
  1: '/system/tableHeaderFilter/update',
  2: '/railway-analysis-server/tableHeaderFilter/update'
}
